<?php
/*
Plugin Name: bstat
Plugin URI: http://maisonbisson.com/blog/search/bstat
Description: Pretty good stats tracking
Version: 0.0.b4 July 20
Author: Casey Bisson
Author URI: http://maisonbisson.com/blog/
*/

/*  Copyright 2005  Casey Bisson

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

global $bstat_hits_table;
$bstat_hits_table = $table_prefix . "bstat_hits";

global $bstat_refs_table;
$bstat_refs_table = $table_prefix . "bstat_refs";



//
// adding the menus 
//
function bstat_add_menu() {
	add_options_page('bstat Settings', 'bstat', 8, __FILE__, 'bstat_optionspage');
	add_management_page('bstat Stats', 'bstat', 2, __FILE__, 'bstat_managementpage');
	//add_submenu_page('index.php', 'bstat Stats', 'bstat', 1, __FILE__, 'bstat_dashboardpage');
	}
// end bstat_add_menu



//
// the adminstration menu 
//
function bstat_optionspage() {
	global $wpdb, $bstat_hits_table, $bstat_refs_table;
	
	
	// configure the tables on first use...
	//
	// get list of tables and look for our tables in it
	$request = "SHOW TABLES;";
	$rows = $wpdb->get_results($request);
	$hits_table = false;
	$refs_table = false;
	foreach($rows as $table) {
		foreach($table as $value) if($value==$bstat_hits_table) $hits_table = true;
		foreach($table as $value) if($value==$bstat_refs_table) $refs_table = true;
		}

	if(!$hits_table){
		$request = "
			CREATE TABLE `$bstat_hits_table` (
				  `bstat_id` bigint(20) unsigned NOT NULL auto_increment,
				  `bstat_date` date NOT NULL default '0000-00-00',
				  `post_id` mediumint(9) unsigned NOT NULL default '0',
				  `hits_reads` mediumint(9) unsigned NOT NULL default '0',
				  `hits_ads1` mediumint(9) unsigned NOT NULL default '0',
				  `hits_ads2` mediumint(9) unsigned NOT NULL default '0',
				  PRIMARY KEY  (`bstat_id`),
				  KEY `date` (`bstat_date`),
				  KEY `post_id` (`post_id`)
				) TYPE=MyISAM
			";
	  	$wpdb->query($request);
		}

	if(!$refs_table){
		$request = "
			CREATE TABLE `$bstat_refs_table` (
				`bstat_id` bigint(20) unsigned NOT NULL auto_increment,
				`bstat_date` date NOT NULL default '0000-00-00',
				`post_id` mediumint(9) unsigned NOT NULL default '0',
				`hits` mediumint(9) unsigned NOT NULL default '0',
				`issearchengine` tinyint(1) NOT NULL default '0',
				`ref` text NOT NULL,
				PRIMARY KEY  (`bstat_id`),
				KEY `date` (`bstat_date`),
				KEY `post_id` (`post_id`),
				KEY `ref` (`ref`(7))
				) TYPE=MyISAM			";
	  	$wpdb->query($request);
	  	}

	if(!$hits_table || !$refs_table):
?>
	<div class="wrap">
		<h2><?=_e("Installation")?></h2>
		<p><?=_e("The <b>bstats</b> plugin is now initialized. The bstats tables have been created, but you must configure your template pages to count hits and display stats. If you choose to deactivate the plugin you must delete the bstats tables manually.")?></p>
	</div>
<?
	endif;

	//  apply new settings if form submitted
	if(isset($_POST['Options'])){
		$bstat_graphaccurate = $_POST['bstat_graphaccurate'] == 1 ? 1 : 0;
		$bstat_refmoderation = $_POST['bstat_refmoderation'] == 1 ? 1 : 0;
		update_option('bstat_graphaccurate', $bstat_graphaccurate);
		update_option('bstat_refmoderation', $bstat_refmoderation);
		update_option('bstat_ignoreips', (ereg_replace("[^0-9*.\n]", "", $_POST['bstat_ignoreips'])));
		echo '<div class="updated"><p><strong>' . __('Options updated.', 'bstat') . '</strong></p></div>';
		}

	// get checkbox status settings
	$bstat_graphaccurate = get_settings('bstat_graphaccurate');
	$ck_bstat_graphaccurate = $bstat_graphaccurate == 1 ? ' checked="checked"' : '';

	$bstat_refmoderation = get_settings('bstat_refmoderation');
	$ck_bstat_refmoderation = $bstat_refmoderation == 1 ? ' checked="checked"' : '';

	//  output settings/configuration form
?>

<div class="wrap">
<h2><?php _e('Settings') ?></h2>
<form method="post">
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Make accurate pulse graphs', 'bstat') ?>:</th>
			<td><input type="checkbox" name="bstat_graphaccurate" id="bstat_graphaccurate" <?php echo $ck_bstat_graphaccurate ?> value="1" /> Enable</td>
		</tr>
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Filter incoming search terms using comment moderation and blacklist words', 'bstat') ?>:</th>
			<td><br /><input type="checkbox" name="bstat_refmoderation" id="bstat_graphaccurate" <?php echo $ck_bstat_refmoderation ?> value="1" /> Enable</td>
		</tr>
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Ignore hits from these IP numbers', 'bstat') ?>:</th>
			<td><textarea name="bstat_ignoreips" cols="25" rows="4" id="format" style="font-size: 12px;" class="code"><?php echo get_settings('bstat_ignoreips'); ?></textarea><br />One IP per line.<br />"10.20.30.*" excludes "10\.20\.30\.(.*)".<br />Current IP = <?php echo $_SERVER[REMOTE_ADDR]; ?></td>
		</tr>
	</table>
	<div class="submit"><input type="submit" name="Options" value="<?php _e('Update Options', 'bstat') ?> &raquo;" /></div>
</form>
</div>


<div class="wrap">
	<h2><?=_e('Documentation')?></h2>

It is essential that <span style="font-family:monospace;">bstat_hitit</span> be activated once (and only once) for every page load. In most themes (including the default and classic), it works perfectly when added to the bottom of the footer.php file.

<pre>&lt;?php // this is the part that makes the bstats plugin work...
    global $id;
    if (!is_single()) $id = 0;
    bstat_hitit($id, "read");
    ?&gt;
</pre>

<p>Once you insert that code, you'll start seeing stats in the <a href="edit.php?page=bstat.php">bstat submenu</a> of the <a href="edit.php">WP manage tab</a>.</p>

<p>Further documentation for this release can be <a href="http://www.maisonbisson.com/blog/post/10662/">found online</a>.</p>

</div>
<?

}
// end bstat_optionspage



//
// the adminstration menu 
//
function bstat_managementpage() {
	global $wpdb, $bstat_hits_table, $bstat_refs_table, $tablecomments, $tableposts;
?>

<div class="wrap">
<h2><?php _e('Quick Stats') ?></h2>

<?php

$before = "<li>";
$after = "</li>\n";
$date  = date("Y-m-d");

$request = "SELECT SUM(hits_reads) AS note 
	FROM $bstat_hits_table
	WHERE bstat_date = '$date'
	";
echo("<table><tr valign='top'><td><h4>Page Loads Today</h4><ul>" . bstat_reporter($request, $before, $after, 1) . "</ul></td>");

echo("<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>");

$request = "SELECT SUM(hits_reads) AS note FROM $bstat_hits_table
	";
echo("<td><h4>Total Page Loads</h4><ul>" . bstat_reporter($request, $before, $after, 1) . "</ul></td></tr></table>");

?>

</div>

<?php

	//  apply new settings if form submitted
	if(isset($_POST['Options'])){
		$bstat_topstories = is_numeric($_POST['bstat_topstories']) == true ? intval($_POST['bstat_topstories']) : 0;
		update_option('bstat_topstories', $bstat_topstories);
		
		$bstat_discussion = is_numeric($_POST['bstat_discussion']) == true ? intval($_POST['bstat_discussion']) : 0;
		update_option('bstat_discussion', $bstat_discussion);
		
		$bstat_referrers = is_numeric($_POST['bstat_referrers']) == true ? intval($_POST['bstat_referrers']) : 0;
		update_option('bstat_referrers', $bstat_referrers);
		
		$bstat_ads = is_numeric($_POST['bstat_ads']) == true ? intval($_POST['bstat_ads']) : 0;
		update_option('bstat_ads', $bstat_ads);
		
		$bstat_period = is_numeric($_POST['bstat_period']) == true ? intval($_POST['bstat_period']) : 0;
		update_option('bstat_period', $bstat_period);
		}



	// get checkbox status settings
	$bstat_topstories = get_settings('bstat_topstories');
	$ck_bstat_topstories = $bstat_topstories <> NULL ? "<option value='$bstat_topstories' selected='selected'>$bstat_topstories</option>" : "<option value='5' selected='selected'>5</option>";
	
	$bstat_discussion = get_settings('bstat_discussion');
	$ck_bstat_discussion = $bstat_discussion <> NULL ? "<option value='$bstat_discussion' selected='selected'>$bstat_discussion</option>" : "<option value='5' selected='selected'>5</option>";
	
	$bstat_referrers = get_settings('bstat_referrers');
	$ck_bstat_referrers = $bstat_referrers <> NULL ? "<option value='$bstat_referrers' selected='selected'>$bstat_referrers</option>" : "<option value='5' selected='selected'>5</option>";
	
	$bstat_ads = get_settings('bstat_ads');
	$ck_bstat_ads = $bstat_ads <> NULL ? "<option value='$bstat_ads' selected='selected'>$bstat_ads</option>" : "<option value='5' selected='selected'>5</option>";
	
	$bstat_period = get_settings('bstat_period');
	$ck_bstat_period = $bstat_period <> NULL ? "<option value='$bstat_period' selected='selected'>past $bstat_period days</option>" : "<option value='8' selected='selected'>This week</option>
";

?>

<div class="wrap">
<h2><?php _e('Stats Control Panel') ?></h2>
<form method="post">
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
		<tr valign="bottom">
			<th width="15%" scope="col" style="text-align: center;"><?php _e('Top Stories', 'bstat') ?>: </th>

			<th width="15%" scope="col" style="text-align: center;"><?php _e('Comments and Trackbacks', 'bstat') ?>: </th>

			<th width="15%" scope="col" style="text-align: center;"><?php _e('Top Referrers', 'bstat') ?>: </th>

<!--			<th width="15%" scope="col" style="text-align: center;"><?php _e('Top Paying Stories', 'bstat') ?>: </th>-->

			<th width="15%" scope="col" style="text-align: center;"><?php _e('Period', 'bstat') ?>: </th>

			<th width="15%" scope="col" style="text-align: center;"><?php _e('Go', 'bstat') ?>: </th>

			</tr>

		<tr valign="top">
			<td style="text-align: center;"><?php _e('show', 'bstat') ?> <select name="bstat_topstories" id="bstat_topstories">
				<? echo $ck_bstat_topstories ?>
				<option value="0">0</option>
				<option value="5">5</option>
				<option value="15">15</option>
				<option value="50">50</option>
				<option value="100">100</option>
				</select></td>

			<td style="text-align: center;"><?php _e('show', 'bstat') ?> <select name="bstat_discussion" id="bstat_discussion">
				<? echo $ck_bstat_discussion ?>
				<option value="0">0</option>
				<option value="5">5</option>
				<option value="15">15</option>
				<option value="50">50</option>
				<option value="100">100</option>
				</select></td>

			<td style="text-align: center;"><?php _e('show', 'bstat') ?> <select name="bstat_referrers" id="bstat_referrers">
				<? echo $ck_bstat_referrers ?>
				<option value="0">0</option>
				<option value="5">5</option>
				<option value="15">15</option>
				<option value="50">50</option>
				<option value="100">100</option>
				</select></td>

<!--			<td style="text-align: center;"><?php _e('show', 'bstat') ?> <select name="bstat_ads" id="bstat_ads">
				<? echo $ck_bstat_ads ?>
				<option value="0">0</option>
				<option value="5">5</option>
				<option value="15">15</option>
				<option value="50">50</option>
				<option value="100">100</option>
				</select></td>-->

			<td style="text-align: center;"><select name="bstat_period" id="bstat_period">
				<? echo $ck_bstat_period ?>
				<option value="1">Today</option>
				<option value="8">This week</option>
				<option value="15">Two Weeks</option>
				<option value="31">Month</option>
				<option value="90">Quarter</option>
				<option value="366">Year</option>
				<option value="3651">10 Years</option>
				</select></td>

			<td style="text-align: center;"><input type="submit" name="Options" value="<?php _e('Show', 'bstat') ?> &raquo;" /></td>

			</tr>
	</table>
</form>
</div>

<?php

$before = "<li>";
$after = "</li>\n";
$date  = date("Y-m-d", mktime(0, 0, 0, date("m")  , date("d") - $bstat_period, date("Y")));

?>

<? if($bstat_topstories > 0){ ?>
<div class="wrap">
<h2><?php _e('Top Stories') ?></h2>

<?php

$request = "SELECT a.post_id AS post_id, LEFT(b.post_title, 60) AS title, ROUND((SUM(a.hits_reads)) / ((TO_DAYS(NOW()) - TO_DAYS(MIN(a.bstat_date))) + 1)) AS sort_order, CONCAT('<br /><small>Tot:</small> ', SUM(a.hits_reads), '<small>, Avg:</small> ', ROUND((SUM(a.hits_reads)) / ((TO_DAYS(NOW()) - TO_DAYS(MIN(a.bstat_date))) + 1)), '<small>, Max:</small> ', MAX(a.hits_reads), '') AS note
		FROM $bstat_hits_table a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND bstat_date > '$date'
		GROUP BY a.post_id
		ORDER BY sort_order DESC
		LIMIT $bstat_topstories
	";
echo("<table><tr valign='top'><td><h4>Most Reads Per Day</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td>");

$request = "SELECT a.post_id AS post_id, LEFT(b.post_title, 60) AS title, SUM(a.hits_reads) AS sort_order, CONCAT('<br /><small>Tot:</small> ', SUM(a.hits_reads), '<small>, Avg:</small> ', ROUND((SUM(a.hits_reads)) / ((TO_DAYS(NOW()) - TO_DAYS(MIN(a.bstat_date))) + 1)), '<small>, Max:</small> ', MAX(a.hits_reads), '') AS note
		FROM $bstat_hits_table a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND bstat_date > '$date'
		GROUP BY a.post_id
		ORDER BY sort_order DESC
		LIMIT $bstat_topstories
	";
echo("<td><h4>Most Total Reads</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td></tr></table>");

?>

</div>
<? } ?>



<? if($bstat_discussion > 0){ ?>
<div class="wrap">
<h2><?php _e('Comments and Trackbacks') ?></h2>

<?php

$request = "SELECT a.comment_post_ID AS post_id, MAX(a.comment_ID) AS comment_id, CONCAT('<br />', MAX(a.comment_date)) AS note,  LEFT(b.post_title, 60) AS title
		FROM $tablecomments a , $tableposts b
		WHERE a.comment_post_ID = b.ID
		AND a.comment_approved = '1'
		AND comment_date > '$date'
		GROUP BY comment_post_id
		ORDER BY note DESC
		LIMIT $bstat_discussion
	";
echo("<table><tr valign='top'><td><h4>Recently Commented Posts</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td>");

$request = "SELECT a.comment_post_ID AS post_id, a.comment_ID AS comment_id, CONCAT('<br />', a.comment_date) AS note, CONCAT(a.comment_author, ' <small>on</small> ', LEFT(b.post_title, 20)) AS title
		FROM $tablecomments a , $tableposts b
		WHERE a.comment_post_ID = b.ID
		AND a.comment_approved = '1'
		AND comment_date > '$date'
		ORDER BY note DESC
		LIMIT $bstat_discussion
	";
echo("<td><h4>Recent Comments</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td></tr></table>");

?>

</div>
<? } ?>



<? if($bstat_referrers > 0){ ?>
<div class="wrap">
<h2><?php _e('Top Referrers') ?></h2>

<?php

$request = "SELECT a.post_id AS post_id, a.ref AS title, SUM(a.hits) AS sort_order, CONCAT('<br />', SUM(a.hits), ' hits, last hit on ', MAX(a.bstat_date)) AS note, 'Go To...' AS tooltip
		FROM $bstat_refs_table a, $tableposts b 
		WHERE a.post_id = b.ID
		AND issearchengine = 1
		AND bstat_date > '$date'
		GROUP BY a.post_id, a.ref
		ORDER BY sort_order DESC
		LIMIT $bstat_referrers
	";
echo("<table><tr valign='top'><td><h4>Top Incoming Searches</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td>");

$request = "SELECT a.ref AS url, LEFT(a.ref, 60) AS title, SUM(a.hits) AS sort_order, CONCAT('<br />', SUM(a.hits), ' hits to ', LEFT(b.post_title, 50)) AS note, 'Go To...' AS tooltip
		FROM $bstat_refs_table a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND issearchengine = 0
		AND bstat_date > '$date'
		GROUP BY a.post_id, a.ref
		ORDER BY sort_order DESC
		LIMIT $bstat_referrers
	";
echo("<td><h4>Top (Non-Search Engine) Referrers</h4><ol>" . bstat_reporter($request, $before, $after, 0) . "</ol></td></tr></table>");

?>

</div>
<? } ?>



<? if($bstat_ads > 0){ ?>
<div class="wrap">
<h2><?php _e('Top Paying Stories') ?></h2>

<?php
$request = "SELECT a.post_id AS post_id, LEFT(b.post_title, 50) AS title, CONCAT('<br /><small>Total:</small> ', SUM((a.hits_ads1 + a.hits_ads2)), '<small>, Rate:</small> ', (SUM((a.hits_ads1 + a.hits_ads2)) / SUM(a.hits_reads))) AS note, (SUM((a.hits_ads1 + a.hits_ads2)) / SUM(a.hits_reads)) AS sort_order
		FROM $bstat_hits_table a, $tableposts b 
		WHERE a.post_id = b.ID
		AND bstat_date > '$date'
		GROUP BY a.post_id
		ORDER BY sort_order DESC
		LIMIT $bstat_ads
	";
echo("<table><tr valign='top'><td><h4>Most Ad Hits Per Read</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td>");

$request = "SELECT a.post_id AS post_id, LEFT(b.post_title, 50) AS title, CONCAT('<br /><small>Total:</small> ', SUM((a.hits_ads1 + a.hits_ads2)), '<small>, Rate:</small> ', (SUM((a.hits_ads1 + a.hits_ads2)) / SUM(a.hits_reads))) AS note, (SUM(a.hits_ads1 + a.hits_ads2)) AS sort_order
		FROM $bstat_hits_table a, $tableposts b 
		WHERE a.post_id = b.ID
		AND bstat_date > '$date'
		GROUP BY a.post_id
		ORDER BY sort_order DESC
		LIMIT $bstat_ads
	";
echo("<td><h4>Most Total Ad Hits</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td></tr></table>");
?>

</div>
<? } ?>



<div class="wrap">
<h2><?php _e('Pulse') ?></h2>

<?php bstat_pulse(0, 800, 1, 0, 1); ?>

</div>

<?

}
// end bstat_managementpage



//
// the dashboard menu 
//
function bstat_dashboardpage() {

?><h2>Here I am</h2><?

}
// end bstat_dashboardpage


//
// Referrer tracking
//
function bstat_getref() {

	$raw_referrer = $_SERVER["HTTP_REFERER"];

	// these fix problems with google.ca's query identifyer
	$raw_referrer = ereg_replace("as_q=", "q=", $raw_referrer);
	$raw_referrer = ereg_replace("as_qdr=", "q=", $raw_referrer);

	// this fixes some sites that don't have a query identifyer
	$raw_referrer = ereg_replace("a9.com/", "a9.com/?q=", $raw_referrer);
	$raw_referrer = ereg_replace("technorati.com/tag", "technorati.com/?q=tag", $raw_referrer);

	$raw_referrer = split("\?", $raw_referrer);
	$referrer = $raw_referrer[0];
	$raw_searchstring = split("&", $raw_referrer[1]);

	$querystringidentifyer = NULL;
	switch (true) {
		case (ereg("google", $referrer)):
			$querystringidentifyer = "q=";
			break;
		case (ereg("yahoo", $referrer)):
			$querystringidentifyer = "p=";
			break;
		case (ereg("altavista", $referrer)):
			$querystringidentifyer = "q=";
			break;
		case (ereg("a9", $referrer)):
			$querystringidentifyer = "q=";
			break;
		case (ereg("aolsearch", $referrer)):
			$querystringidentifyer = "query=";
			break;
		case (ereg("search.msn", $referrer)):
			$querystringidentifyer = "q=";
			break;
		case (ereg("dashbar", $referrer)):
			$querystringidentifyer = "k=";
			break;
		case (ereg("mywebsearch", $referrer)):
			$querystringidentifyer = "searchfor=";
			break;
		case (ereg("mysearch", $referrer)):
			$querystringidentifyer = "searchfor=";
			break;
		case (ereg("baidu", $referrer)):
			$querystringidentifyer = "word=";
			break;
		case (ereg("technorati.com", $referrer)):
			$querystringidentifyer = "q=";
			break;
		default:
			$querystringidentifyer = "q=";
			//echo "$referrer $raw_referrer[1]\n";
			break;
		}
	
	$searchstring = NULL;
	foreach($raw_searchstring as $test_searchstring){
		if(ereg(("^" . $querystringidentifyer), $test_searchstring)){
			$searchstring = urldecode(ereg_replace($querystringidentifyer, "", $test_searchstring));
			}
		}
	if(!$searchstring){
		$issearchengine = 0;
		$searchstring = $_SERVER["HTTP_REFERER"];
	}else{
		$issearchengine = 1;
		}

	$result = NULL;
	$result[issearchengine] = $issearchengine;
	$result[searchstring] = $searchstring;

	return($result);
	}
// end function bstat_getref



//
// ignore hits from certain IPs (configure in options tab)
// returns true if the client IP matches one in get_settings('bstat_ignoreips')
// this feature requested by Zach, blame him for any problems....
//
function bstat_ignorethisip() {
	//echo "<h1>Looking for IPs to ignore...</h1>";
	$bstat_ignoreips = ereg_replace("\.", "\\.", get_settings('bstat_ignoreips')); 
	$bstat_ignoreips = ereg_replace("\*", "(.*)", $bstat_ignoreips);
	$bstat_ignoreips = explode("\n", $bstat_ignoreips);
	foreach($bstat_ignoreips as $ignoreip){
		//$ignoreip = substr($ignoreip, 0, -1);
		if($ignoreip){
			//echo "<h1>$ignoreip</h1>";
			if(ereg("^" . $ignoreip . "$", $_SERVER[REMOTE_ADDR])){
				//echo "<h1>IP Match</h1>";
				return(true);
				}
			}
		}
	return(false);
	}
// end function bstat_ignorethisip



//
// increment the hit counters for story reads and ad hits
//
function bstat_hitit($post_id, $what) {
	global $wpdb, $bstat_hits_table, $bstat_refs_table;

	if(!((get_settings('bstat_ignoreips')) && (bstat_ignorethisip()))){
		$hits_reads = 0;
		$hits_ads1 = 0;
		$hits_ads2 = 0;
		
		$date = date("Y-m-d");
	
		$request = "SELECT * FROM $bstat_hits_table 
			WHERE post_id = $post_id
			AND bstat_date = '$date'
			LIMIT 1
			";
	
		$rows = $wpdb->get_results($request);
	
		if(count($rows)==0){
			switch($what){
				case "read":
					$hits_reads = 1;
					break;				
				case "ads1":
					$hits_ads1 = 1;
					break;				
				case "ads2":
					$hits_ads2 = 1;
					break;
				default:
					$hits_reads = 1;
					break;				
				}
				
			$request = "INSERT INTO $bstat_hits_table 
				(bstat_date, post_id, hits_reads, hits_ads1, hits_ads2) VALUES ('$date', $post_id, $hits_reads, $hits_ads1, $hits_ads2);";
	
		}else{
			$request = "UPDATE $bstat_hits_table ";
			
			foreach($rows as $row){
				switch($what){
					case "read":
						$request .= "SET hits_reads = " . ($row->hits_reads + 1) . " ";
						break;				
					case "ads1":
						$request .= "SET hits_ads1 = " . ($row->hits_ads1 + 1) . " ";
						break;				
					case "ads2":
						$request .= "SET hits_ads2 = " . ($row->hits_ads2 + 1) . " ";
						break;
					default:
						$request .= "SET hits_reads = " . ($row->hits_reads + 1) . " ";
						break;				
					}
				}
				$request .= "WHERE bstat_id = " . $row->bstat_id;
			}
	
		$wpdb->query($request);
		}
	

	//
	// now track the referer tags
	//
	$referer = bstat_getref();


	//
	// now filter comments based on WP's kill lists
	//
	$blacklist = get_option('bstat_refmoderation');
	if($blacklist == 1){ 	
		$blacklist = get_option('moderation_keys');
		$blacklist .= "\n";
		$blacklist .= get_option('blacklist_keys');
		$blacklist = explode("\n", $blacklist);

		foreach($blacklist as $killword){
			$killword = substr($killword, 0, -1);
			//echo "<h1>$killword, $referer[searchstring]</h1>";
			if($killword){
				if(eregi($killword, $referer[searchstring])){
					//echo "<h1>Hit!</h1>";
					$referer[issearchengine] = 0;
					}
				}
			}
		}

	if($referer[searchstring]){
		$request = "SELECT * FROM $bstat_refs_table 
			WHERE post_id = $post_id
			AND bstat_date = '$date'
			AND ref = '$referer[searchstring]'
			LIMIT 1
			";
	
		$rows = $wpdb->get_results($request);
	
		if(count($rows)==0){
			$request = "INSERT INTO $bstat_refs_table 
				(bstat_date, post_id, hits, issearchengine, ref) VALUES ('$date', $post_id, 1, '$referer[issearchengine]', '$referer[searchstring]');";
	
		}else{
			$request = "UPDATE $bstat_refs_table ";
			
			foreach($rows as $row){
				$request .= "SET hits = " . ($row->hits + 1) . " ";
				}
			$request .= "WHERE bstat_id = " . $row->bstat_id;
			}
	
		$wpdb->query($request);

		//echo "<h1>$request</h1>";
		//print_r($referer);
		}
	}
// end function bstat_hitit



//
// fetch the data, format it, return it
//
function bstat_reporter($request, $before, $after, $baseurl) {
	global $wpdb; 

	if($baseurl == 0){
		$baseurl = "";
	}else if($baseurl == 1){
		$baseurl = get_settings('home') . "/";
		}

	$rows = $wpdb->get_results($request);
	
	if(count($rows)>0){
		$report = "";
		foreach($rows as $row){
			if(($row->post_id) && ($row->comment_id)){
				$url = (get_permalink($row->post_id) . "#comment-" . ($row->comment_id));
			}else if($row->post_id){
				$url = get_permalink($row->post_id);
			}else{
				$url = ($baseurl . ($row->url));
				}

			$report .= $before . "<a href='" . $url . "' title='" . ($row->tooltip) . "'>" . ($row->title) . "</a>" . ($row->note) . $after;
			}
		return($report);
		}
	}
// end function bstat_reporter



//
// Display today's popular stories
//
function bstat_todaypop($maxresults, $before, $after) {
	global $wpdb, $bstat_hits_table, $tableposts;

	$date  = date("Y-m-d");

	$request = "SELECT a.post_id AS post_id, b.post_title AS title, a.hits_reads AS sort_order, CONCAT(' (', a.hits_reads, ')') AS note
		FROM $bstat_hits_table a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND bstat_date = '$date'
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";
		
	echo(bstat_reporter($request, $before, $after, 1));

	}
// end function bstat_todaypop



//
// Display recently popular stories
//
function bstat_recentpop($maxresults, $days, $before, $after) {
	global $wpdb, $bstat_hits_table, $tableposts;

	$date  = date("Y-m-d", mktime(0, 0, 0, date("m")  , date("d") - $days, date("Y")));

	$request = "SELECT a.post_id AS post_id, b.post_title AS title, SUM(a.hits_reads) AS sort_order, CONCAT(' (', SUM(a.hits_reads), ')') AS note
		FROM $bstat_hits_table a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND bstat_date > '$date'
		GROUP BY a.post_id
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";
		
	echo(bstat_reporter($request, $before, $after, 1));

	}
// end function bstat_recentpop



//
// Display today's search terms
//
function bstat_todayrefs($maxresults, $before, $after) {
	global $wpdb, $bstat_refs_table, $tableposts;

	$date  = date("Y-m-d");

	$request = "SELECT a.post_id AS post_id, a.ref AS title, a.hits AS sort_order, CONCAT(' (', a.hits, ')') AS note
		FROM $bstat_refs_table a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND issearchengine = 1
		AND bstat_date = '$date'
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";
		
	echo(bstat_reporter($request, $before, $after, 1));

	}
// end function bstat_todayrefs



//
// Display recent search terms
//
function bstat_recentrefs($maxresults, $days, $before, $after) {
	global $wpdb, $bstat_refs_table, $tableposts;

	$date  = date("Y-m-d", mktime(0, 0, 0, date("m")  , date("d") - $days, date("Y")));

	$request = "SELECT a.post_id AS post_id, a.ref AS title, SUM(a.hits) AS sort_order, CONCAT(' (', SUM(a.hits), ')') AS note
		FROM $bstat_refs_table a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND issearchengine = 1
		AND bstat_date > '$date'
		GROUP BY a.post_id, a.ref
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";
		
	echo(bstat_reporter($request, $before, $after, 1));

	}
// end function bstat_recentrefs



//
// Display all search terms for a particular story
//
function bstat_refsforpost($post_id, $before, $after) {
	global $wpdb, $bstat_refs_table, $tableposts;

	$request = "SELECT '$post_id' AS post_id, a.ref AS title, SUM(a.hits) AS sort_order, CONCAT(' (', SUM(a.hits), ')') AS note
		FROM $bstat_refs_table a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND issearchengine = 1
		AND a.post_id = $post_id
		GROUP BY a.ref
		ORDER BY sort_order DESC
		";
		
	echo(bstat_reporter($request, $before, $after, 1));

	}
// end function bstat_refsforpost




//
// Display recently commented stories
//
function bstat_discussionbypost($maxresults, $before, $after) {
	global $wpdb, $tablecomments, $tableposts; 

	$request = "SELECT a.comment_post_ID AS post_id, MAX(a.comment_ID) AS comment_id, b.post_title AS title, CONCAT(' (', COUNT(*), ')') AS note, MAX(a.comment_date) AS sort_order
		FROM $tablecomments a , $tableposts b
		WHERE a.comment_post_ID = b.ID
		AND a.comment_approved = '1'
		GROUP BY comment_post_id
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";
		
	echo(bstat_reporter($request, $before, $after, 1));

	}
// end function bstat_discussionbypost



//
// Display recent comments
//
function bstat_discussionbycomment($maxresults, $before, $after) {
	global $wpdb, $tablecomments, $tableposts; 

	$request = "SELECT a.comment_post_ID AS post_id, a.comment_ID AS comment_id, b.post_title AS title, CONCAT(' (', a.comment_author, ')') AS note, a.comment_date AS sort_order
		FROM $tablecomments a , $tableposts b
		WHERE a.comment_post_ID = b.ID
		AND a.comment_approved = '1'
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";
		
	echo(bstat_reporter($request, $before, $after, 1));

	}
// end function bstat_discussionbycomment



//
// Output JavaScript for ad rollover tracking
//
function bstat_ad_tracking_js() {
	if(ereg("\?",$_SERVER[REQUEST_URI])){
		$bstat_url = ($_SERVER[REQUEST_URI] . "&bstat_event=");
	}else{
		$bstat_url = ($_SERVER[REQUEST_URI] . "?bstat_event=");
		}
?>

<script type="text/javascript">
var bstat_req;
function bstat_initialize(){
	try{
		bstat_req=new ActiveXObject("Msxml2.XMLHTTP");
		}
	catch(e){
		try{
			bstat_req=new ActiveXObject("Microsoft.XMLHTTP");
			}
		catch(oc){
			bstat_req=null;
			}
		}

	if(!bstat_req&&typeof XMLHttpRequest!="undefined"){
		bstat_req=new XMLHttpRequest();
		}
	}

function bstat_hitit(what, post_id){
	//document.getElementById("bstat_test").innerHTML = "<h2>"+stuff+"</h2>";

	bstat_initialize();

	if(bstat_req!=null){
		var bstat_hiturl=("<?php echo $bstat_url; ?>" + what);
		//alert(bstat_hiturl);
		bstat_req.open("GET", bstat_hiturl, true);
        bstat_req.send(null);
		}
	}
</script>

<?
	}
// end function bstat_ad_tracking_js



//
// Display pulse graph for story
//
function bstat_pulse($post_id = 0, $maxwidth = 400, $disptext = 1, $dispcredit = 1, $style = 1) {
	global $wpdb, $bstat_hits_table;

	if($post_id == 0){
		$request = "SELECT SUM(hits_reads) AS hits_reads, bstat_date
			FROM $bstat_hits_table
			GROUP BY bstat_date
			ORDER BY bstat_date ASC
			";
	}else{
		$request = "SELECT hits_reads, bstat_date
			FROM $bstat_hits_table
			WHERE post_id = $post_id
			ORDER BY bstat_date ASC
			";
		}

	$rows = $wpdb->get_results($request);
	$tot = count($rows);
	
	if(count($rows)>0){
		$point = null;
		$point[] = 0;
		foreach($rows as $row){
			$point[] = $row->hits_reads;
			}
		$sum = array_sum($point);
		$max = max($point);
		$avg = round($sum / $tot);


		$graphaccurate = get_option('bstat_graphaccurate');
		
		$minwidth = ($maxwidth / 8.1);
		if($graphaccurate) $minwidth = ($maxwidth / 4.1);
		
		while(count($point) <= $minwidth){
			$newpoint = null;
			for ($i = 0; $i < count($point); $i++) {
				if($i > 0){
					if(!$graphaccurate) $newpoint[] = ((($point[$i-1] * 2) + $point[$i]) / 3);
					$newpoint[] = (($point[$i-1] + $point[$i]) / 2);
					if(!$graphaccurate) $newpoint[] = (($point[$i-1] + ($point[$i-1] * 2)) / 3);
					}
				$newpoint[] = $point[$i];
				}
			$point = $newpoint;
			}


		$tot = count($point);
		$width = round($maxwidth / $tot);
		if($width > 3)
			$width = 4;

		if(($width  * $tot) > $maxwidth)
			$skipstart = (($width  * $tot) - $maxwidth) / $width;

		$i = 1;
		$hit_chart = "";
		foreach($point as $row){
			if((!$skipstart) || ($i > $skipstart)){
				$hit_chart .= "<img src='" . get_settings('home') . "/wp-content/spacer.gif' width='$width' height='" . round((($row) / $max) * 100) . "' alt='graph element.' />";
				}
			$i++;
			}
			
		$pre = "";
		$post = "";
		if($style == 1){
			$pre = "
<style type=\"text/css\">
<!--
#bstat_pulse	{ height: 130px; margin: 2px 0px 2px 0px; text-align:center; } 
#bstat_pulse p	{ text-align: center; line-height: 1em; text-shadow: #ffffff 1px 1px 4px; margin-top: 0px; } 
#bstat_pulse img	{ display:inline; vertical-align: middle; background-color: #999999; border: solid 0px #000000; margin: 0px 0px 0px 0px; padding: 0px 0px 0px 0px; border-top: solid 2px #000000; } 
-->
</style>
<div id=\"bstat_pulse\">";
			$post = "</div>
				";
			}
		$disptext = ($disptext == 1) ? ("$sum total reads, averaging $avg daily") : ("");
		$dispcredit = ($dispcredit == 1) ? ("<small><a href='http://maisonbisson.com/blog/search/bstat' title='pretty good stats software'>stats powered by bstat</a></small>") : ("");
		$disptext = (($disptext) || ($dispcredit)) ? ("\n<p>$disptext\n<br />$dispcredit</p>") : ("");
		

		//echo("<div id=\"bstat_pulse\">$hit_chart\n\n<p>$sum total reads, averaging $avg daily\n<br /><small><a href='http://maisonbisson.com/blog/search/bstat' title='pretty good stats software'>stats powered by bstat</a></small></p></div>");
		echo($pre . $hit_chart . "\n" . $disptext . $post);
		}
	}
// end function bstat_pulse



//
// the simple part of the search engine highlighting routine from Suda
// http://suda.co.uk/projects/SEHL/
// used here under GPL
//
function sehl_do_highlight($full_body, $q, $colour){
	/* seperate tags and data from the HTML file INCLUDING comments, avoiding HTML in the comments */
	$pat = '/((<[^!][\/]*?[^<>]*?>)([^<]*))|((<!--[ \r\n\t]*)(.*)[ \r\n\t]*-->([^<]*))/si';
	preg_match_all($pat,$full_body,$tag_matches);

	/* loop through and highlight $q value in data and recombine with tags */
	for ($i=0; $i< count($tag_matches[0]); $i++) {
		/* ignore all text within these tags */
		if (
			(preg_match('/<!/i', $tag_matches[0][$i])) or 
			(preg_match('/<textarea/i', $tag_matches[2][$i])) or 
			(preg_match('/<script/i', $tag_matches[2][$i]))
		){
			/* array[0] is everything the REGEX found */
			$full_body_hl .= $tag_matches[0][$i];
//			$full_body_hl .= $tag_matches[2][$i].$tag_matches[3][$i];
		} else {
			$full_body_hl .= $tag_matches[2][$i];

			/* the slash-i is for case-insensitive and the slash-b's are for word boundries */

			/* this one ALMOST works, except if the string is at the start or end of a string*/
			$holder = preg_replace('/(.*?)(\W)('.preg_quote($q).')(\W)(.*?)/iu',"\$1\$2<span class=\"hl$colour\">\$3</span>\$4\$5",' '.$tag_matches[3][$i].' ');
			$full_body_hl .= substr($holder,1,(strlen($holder)-2));

			/* ORIGINAL REGEX with word boundries */
			/*
			$full_body_hl .= preg_replace("/(.*?)\b(".preg_quote($q).")\b(.*?)/i", "\$1<span class=\"hl$colour\">\$2</span>\$3", $tag_matches[3][$i]);
			*/
		}
	}
	/* return tagged text */
	return $full_body_hl;
}



//
// highlite search terms
//
function bstat_hiliter($content) {

	/* initialise variables */
	$colour      = 0; /* zero-out variables */
	$max_colours = 5; /* Number of highlight colours in the css */
	$notice	= "";
	
	$ref = bstat_getref();
	$refs = explode(" ", $ref[searchstring]);
	
	if((count($refs > 0) && ($ref[issearchengine] == 1))){
		if(count($refs > 1)){
			$notice = "<div id='bstat_hilite'>The following search terms have been highlighted: ";
		}else{
			$notice = "<div id='bstat_hilite'>The following search term has been highlighted: ";
			}
		
		foreach($refs as $ref){
			$thiscolour = bcmod($colour,$max_colours);
			$content = sehl_do_highlight($content, $ref, $thiscolour);
			$notice .= "<span class=\"hl$thiscolour\">$ref</span> ";
			$colour++;
			}
		$notice .= "</div>\n";
		}
	
	return($notice.$content);
	}
// end function bstat_highliter



//
// register WordPress hooks
//
add_action('admin_menu', 'bstat_add_menu');
//add_filter('the_content', 'bstat_hiliter', 9);
// end register WordPress hooks